const YesNoNode = require( '../YesNoNode' );
const TreeNode = require( '../TreeNode' );
const UseAbility = require( '../UseAbility' );
const BattleCalc = require( '../../BattleCalc' );
const AICalc = require( '../AICalc' );

const Q_any_nearby_allies = function( actor, battleState, moveTowardsTree ) {
	const node = new YesNoNode( actor, battleState );

	node.DEFINE_NEARBY = 3;
	
	node.branches[node.NO] = moveTowardsTree;
	
	if( BattleCalc.getEquippedAbility( actor, 'chain_pull') ) {
		node.branches[node.YES] = new UseAbility( actor, 'chain_pull' );
	} else {
		node.branches[node.YES] = node.branches[node.NO];
	}				
	
	node.query = function()	{
		if( node.yesNoEvalFunction() ) {
			return this.branches[node.YES].query( this.battleState.getNearestEnemyOf(this.actor) );
		} else {
			return this.branches[node.NO].query( this.battleState.getNearestEnemyOf(this.actor) );
		}
	};
	
	node.yesNoEvalFunction = function() {
		return AICalc.getNearbyUnits( this.actor, this.battleState.getAlliesOfUnit(this.actor), this.DEFINE_NEARBY ).length > 0;
	};
	
	return node;
}
module.exports = Q_any_nearby_allies
