/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */
const TreeNode = require('../TreeNode');
const BattleCalc = require('../../BattleCalc');
const UseAbility = require('../UseAbility');

const Q_most_damage = function(actor, battleState) {
  const node = new TreeNode(actor, battleState);

  // branch indexes
  node.ARROW_SHOT = 0;
  node.VOID_SPIKE = 1;
  node.NO_RANGED = 2;

  node.voidSpike = BattleCalc.getEquippedAbility(actor, 'void_spike');
  node.arrowShot = BattleCalc.getEquippedAbility(actor, 'arrow_shot');

  if (node.voidSpike && node.arrowShot)  {
    node.branches[ node.VOID_SPIKE ] = new UseAbility(actor, 'void_spike');
    node.branches[ node.ARROW_SHOT ] = new UseAbility(actor, 'arrow_shot');
  } else if (node.voidSpike && !node.arrowShot) {
    node.branches[ node.VOID_SPIKE ] = new UseAbility(actor, 'void_spike');
    node.branches[ node.ARROW_SHOT ] = node.branches[ node.VOID_SPIKE ];
  } else if (node.arrowShot && !node.voidSpike) {
    node.branches[ node.ARROW_SHOT ] = new UseAbility(actor, 'arrow_shot');
    node.branches[ node.VOID_SPIKE ] = node.branches[ node.ARROW_SHOT ];
  } else {
    node.branches[ node.VOID_SPIKE] = new TreeNode(null, null);
    node.branches[ node.ARROW_SHOT] = node.branches[ node.VOID_SPIKE ];
  }

  node.query = function(data) {
    // input should be a 2-element array: [ bestMissileTarget, topDamageHandle ]

    if (data[1] == 'arrow_shot') {
      return this.branches[this.ARROW_SHOT].query(data[0]);
    } else {
      return this.branches[this.VOID_SPIKE].query(data[0]);
    }
  };

  return node;
};
module.exports = Q_most_damage;
