/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */
const YesNoNode = require( '../YesNoNode' );
const Q_who_closer = require( './Q_who_closer' );
const BattleCalc = require( '../../BattleCalc' );

const Q_tank_between_ally_and_menacer = function( actor, battleState, aggroNode, moveTowards ) {
	const node = new YesNoNode( actor, battleState );

	node.branches[ node.YES ] = aggroNode;
	node.branches[ node.NO ] = new Q_who_closer( actor, battleState, aggroNode, moveTowards );

		
	node.query = function( ally ) {
		// input should be the nearest injured ally
		var hurtAllyAndMenacer = [ ally, this.battleState.getNearestEnemyOf(ally) ];
		
		if( this.yesNoEvalFunction( hurtAllyAndMenacer) ) {
			return this.branches[this.YES].query();
		} else {
			return this.branches[this.NO].query( hurtAllyAndMenacer );		
		}
	}
	
	node.yesNoEvalFunction = function( hurtAllyAndMenacer )	{
		var allies = this.battleState.getAlliesOfUnit( this.actor );

		for( var i = 0; i < allies.length; ++i ) {
			var ally = allies[ i ];

			if( 	ally.tank
				&&	BattleCalc.pieceIsBetweenPair(ally,hurtAllyAndMenacer) )
			{
				return true;
			}
		}
		
		return false;
	}

	return node;
}
module.exports = Q_tank_between_ally_and_menacer
