const EquipmentSpawnEvent = function(battleState) {
  this.eventHandle = 'equipment_spawn';

  this.execute = (tile, item) => {
    this.tileId = tile.uid;
    this.item = item;

    if (tile.loot) {
      if (tile.loot.equipment) {
        tile.loot.equipment.push(item);
      } else {
        tile.loot.equipment = [item];
      }
    } else {
      tile.loot = {
        equipment: [item],
      };
    }

    this.affectedPieces = [tile];
    battleState.onBattleEvent(this);
  };
};
module.exports = EquipmentSpawnEvent;
