const giant_rat = (level) => {
  return {
    handle: 'giant_rat',
    level,
    getAbilityTrees: () => ([{
      handle: 'giant_rat_abilities',
      abilities: {
        move: { handle: 'move', level: 1 },
        melee_attack: { handle: 'melee_attack', level: 1 },
      },
    }]),
    getBaseAttributes: ((bound_level) => ({
      learning: Math.round(1 + bound_level * 0.25 + Math.random() * 3),
      perception: Math.round(1 + bound_level * 0.5 + Math.random() * 3),
      mana: Math.round(1 + bound_level * 0.25 + Math.random() * 3),
      toughness: Math.round(1 + bound_level * 0.25 + Math.random() * 3),
      strength: Math.round(1 + bound_level * 0.5 + Math.random() * 3),
      willpower: Math.round(1 + bound_level * 0.25 + Math.random() * 3),
      dexterity: Math.round(1 + bound_level * 0.75 + Math.random() * 3),
    })).bind(null, level),
    getDefaultAIConfig: () => (['dps_close', 'tank', 'interference', 'support', 'dps_ranged']),
    getStarterEquipment: () => ({}),
    xpValue: level * 2,
    bags: [],
    build: {
      ai: {
        priorities: ['dps_close', 'tank', 'interference', 'support', 'dps_ranged'],
        settings: {
          chanceToSkipRoles: true,
          autoMove: true,
          waitForAPMP: false,
        },
      },
      ai_unit: true,
      beast: true,
      equipment_assignment: {},
      equipped_abilities: ['move','melee_attack'],
      handle: 'giant_rat',
      level,
      team: 'black',
      unit: true,
    },
  };
};
module.exports = giant_rat;
