const huge_bat = (level) => {
  const handle = 'huge_bat';
  const AI_PRIORITIES = ['dps_close', 'tank', 'interference', 'support', 'dps_ranged'];
  const bags = [];

  return {
    handle,
    level,
    getAbilityTrees: ((bound_level) => ([{
      handle: 'huge_bat_abilities',
      abilities: {
        move: { handle: 'move', level: 1 },
        melee_attack: { handle: 'melee_attack', level: 1 },
        blurred_form: { handle: 'blurred_form', level: Math.min(10,Math.round(1+bound_level/2)) },
        quickness: { handle: 'quickness', level: Math.min(10,Math.round(1+bound_level/2)) },
        freedom: { handle: 'freedom', level: Math.min(10,Math.round(1+bound_level/2)) },
      },
    }])).bind(null, level),
    getBaseAttributes: ((bound_level) => ({
      learning: Math.round(1 + bound_level*0.25 + Math.random()*3),
      perception: Math.round(2 + bound_level*1 + Math.random()*3),
      mana: Math.round(1 + bound_level*0.25 + Math.random()*3),
      toughness: Math.round(1.3 + bound_level*0.65 + Math.random()*3),
      strength: Math.round(1 + bound_level*0.5 + Math.random()*3),
      willpower: Math.round(1 + bound_level*0.25 + Math.random()*3),
      dexterity: Math.round(1 + bound_level*0.75 + Math.random()*3),
    })).bind(null, level),
    getDefaultAIConfig: () => AI_PRIORITIES,
    xpValue: level * 15,
    bags,
    build: {
      ai: {
        priorities: AI_PRIORITIES,
        settings: {
          chanceToSkipRoles: true,
          autoMove: true,
          waitForAPMP: false,
        },
      },
      ai_unit: true,
      beast: true,
      equipment_assignment: {},
      equipped_abilities: ['move', 'melee_attack'],
      handle,
      humanoid: false,
      level,
      team: 'black',
      undead: false,
      unit: true,
    },
  };
};
module.exports = huge_bat;
