var ItemGenerator = require('../../../game_items/ItemGenerator.js');
var HeavyHelmet = require('../../../game_items/equipment/helmet/HeavyHelmet.js');
var HeavyTorsoe = require('../../../game_items/equipment/torsoe/HeavyTorsoe.js');
var HeavyBoots = require('../../../game_items/equipment/boots/HeavyBoots.js');
var Sword = require('../../../game_items/equipment/weapon/Sword.js');
var Shield = require('../../../game_items/equipment/off_hand/Shield.js');

module.exports = function() {
  return {
    handle: 'knight',
    unit: true,
    attributes: {
      base: {
        learning: 50,
        perception: 50,
        mana: 50,
        toughness: 50,
        strength: 50,
        willpower: 50,
        dexterity: 50,
        regeneration: 0,
        speed: 0,
        magicalGravity: 0,
        meleeDamage: 0,
        armorClass: 0,
        dodgeChance: 0,
        physicalResil: 0,
        mentalResil: 0,
      },
      fromUpgrades: {
        learning: 0,
        perception: 0,
        mana: 0,
        toughness: 0,
        strength: 0,
        willpower: 0,
        dexterity: 0,
      },
    },
    abilityTrees: [{
      handle: 'skeleton_abilities',
      abilities: {
        move: { handle: 'move',                level: 1 },
        melee_attack: { handle: 'melee_attack',        level: 1 },
        quickness: { handle: 'quickness',           level: 10 },
        bash: { handle: 'bash',                level: 10 },
        suture: { handle: 'suture',              level: 10 },
        slash: { handle: 'slash',               level: 10 },
        slam: { handle: 'slam',                level: 10 },
        taunt: { handle: 'taunt',               level: 10 },
        // armor_break:            {handle: 'armor_break',         level:10},
        roundhouse: { handle: 'roundhouse',          level: 10 },
        mortal_strike: { handle: 'mortal_strike',       level: 10 },
        sky_hammer: { handle: 'sky_hammer',          level: 10 },
        leap: { handle: 'leap',                level: 10 },
      },
    }],
    equipped_abilities: ['move','melee_attack','quickness','bash','suture','slash','slam','taunt',/*'armor_break',*/'roundhouse','mortal_strike','sky_hammer','leap'],
    ai: {
      priorities: ['dps_close', 'tank', 'interference', 'support', 'dps_ranged'],
      settings: {
        chanceToSkipRoles: true,
        autoMove: true,
        waitForAPMP: false,
      },
    },
    equipment: {
      helmet: ItemGenerator.getRandomItem(HeavyHelmet, 1.0, 1.0),
      torsoe: ItemGenerator.getRandomItem(HeavyTorsoe, 1.0, 1.0),
      boots: ItemGenerator.getRandomItem(HeavyBoots, 1.0, 1.0),
      weapon: ItemGenerator.getRandomItem(Sword, 1.0, 1.0),
      off_hand: ItemGenerator.getRandomItem(Shield, 1.0, 1.0),
    },
  };
};